# $Revision: 1.99 $, $Date: 2006/09/09 01:13:46 $
# TODO:
# - check why initgroups() crashes on AMD64 and something, better than
#   disabling initgroups() completely, with that
# - no/more secure initial user/password settings (currently: zope/zope)
# - ZEO support (mkzeoinstance is not tested and probably doesn't work)
# - perl support?
# - update to 2.9.x? rename to Zope27?
# - how to apply the hotfix?

Summary:	An application server and portal toolkit for building Web sites
Summary(es):	Un servidor de aplicaciones y un conjunto de herramientas para la construccin de sitios Web
Summary(pl):	Serwer aplikacji i toolkit portalowy do tworzenia serwisw WWW
Summary(pt_BR):	Um servidor de aplicaes e um conjunto de ferramentas para construo de sites Web
Name:		Zope
Version:	2.7.7
# %%define		sub_ver b2
Release:	4
License:	Zope Public License (ZPL)
Group:		Networking/Daemons
Source0:	http://www.zope.org/Products/Zope/%{version}/%{name}-%{version}-final.tgz
# Source0-md5:	66876823e53fbd0d4a8a7262d7ce251b
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.logrotate
Source4:	%{name}-mkzopeinstance
Source5:	%{name}-mkzeoinstance
Source6:	%{name}-runzope
Source7:	%{name}-zopectl
Source8:	%{name}-installzopeproduct
Source9:	http://www.zope.org/Products/Zope/Hotfix-2006-07-05/Hotfix-20060705/Hotfix_20060705.tar.gz
# Source9-md5:	6dec58130117fd860adc7fd58f8062e7
Patch0:		%{name}-default_config.patch
Patch1:		%{name}-instance_paths.patch
Patch2:		%{name}-pld_makefile_fix.patch
Patch3:		%{name}-no_initgroups.patch
URL:		http://www.zope.org/
BuildRequires:	perl-base
BuildRequires:	python-devel >= 1:2.3.3
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	expat >= 1.95.7
Requires:	logrotate
Requires:	python >= 2.3.3
Requires:	python-PyXML >= 0.8.3
Requires:	python-libs >= 2.3.3
Requires:	python-modules >= 2.3.3
Requires:	rc-scripts
%pyrequires_eq	python
Provides:	group(zope)
Provides:	user(zope)
Obsoletes:	Zope-Hotfix = 040713
Obsoletes:	Zope-Hotfix = 040714
Obsoletes:	Zope-Hotfix = 050405
# extracted from lib/python/App/Hotfixes.py
Obsoletes:	Zope-Hotfix = 2001-09-28
Obsoletes:	Zope-Hotfix = 2002-03-01
Obsoletes:	Zope-Hotfix = 2002-04-15
Obsoletes:	Zope-Hotfix = 2002-06-14
# See Source9
Obsoletes:	Zope-Hotfix = 20060704
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		zope_dir /usr/lib/zope

%description
The Z Object Programming Environment (Zope) is a free, Open Source
Python-based application server for building high-performance, dynamic
web sites, using a powerful and simple scripting object model and
high-performance, integrated object database.

%description -l es
Zope es una aplicacin basada en Python, Open Source[tm], para la
construccin de sitios dinmicos, usa un modelo de escritura de
guiones poderoso y sencillo. Para instalar la aplicacin Zope, instale
ese paquete y despus, Zope-server, para un servidor HTTP integrado
simple, Zope-pcgi, para uso con el servidor Apache. Si desea instalar
solamente algunas partes de la aplicacin Zope, estn diponibles otros
subpaquetes, usted debe instalar stos en vez de ese RPM.

%description -l pl
Zope (Z Object Programming Environment - Obiektowe rodowisko
Programistyczne Z) jest opartym o Pythona serwerem aplikacji do
tworzenia wysoko wydajnych, dynamicznych serwisw WWW, przy uyciu
uytecznego i prostego modelu obiektowego skryptw oraz wysoko
wydajnej zintegrowanej obiektowej bazy danych.

%description -l pt_BR
Zope  uma aplicao baseada em Python, Open Source[tm], para
construo de sites dinmicos, usando um modelo de scripting poderoso
e simples Para instalar o Zope, instale esse pacote e depois, ou o
Zope-server, para um servidor HTTP integrado simples, ou Zope-pcgi,
para uso com o Apache. Se voc quiser instalar apenas algumas partes
do Zope, outros sub-pacotes esto disponveis, e voc deveria instalar
eles ao invs desse RPM.

%prep
%setup -q -a9 -n %{name}-%{version}-final
%patch0 -p1
%patch1 -p1
%patch2 -p1
%ifarch %{x8664} alpha
%patch3 -p1
%endif
# how to apply the hotfix?
#mv Hotfix_20060705 lib/python/Products

%build
./configure \
	--prefix=%{zope_dir} \
	--with-python=%{__python} \
	--optimize

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{/var/lib/zope/main,/var/run/zope,/var/log/zope/main} \
	$RPM_BUILD_ROOT{/etc/logrotate.d,/etc/sysconfig,/etc/rc.d/init.d} \
	$RPM_BUILD_ROOT{%{_sysconfdir}/zope/main,%{_sbindir}} \
	$RPM_BUILD_ROOT%{zope_dir}/bin

ln -sfn %{_bindir}/python $RPM_BUILD_ROOT%{zope_dir}/bin/python

%{__make} install \
	INSTALL_FLAGS="--root $RPM_BUILD_ROOT"

mv $RPM_BUILD_ROOT%{zope_dir}/bin/zpasswd.py $RPM_BUILD_ROOT%{_sbindir}/zpasswd
mv $RPM_BUILD_ROOT%{zope_dir}/skel $RPM_BUILD_ROOT%{_sysconfdir}/zope
mv $RPM_BUILD_ROOT{%{zope_dir}/import/*,%{_sysconfdir}/zope/skel/import}

rm -rf $RPM_BUILD_ROOT%{zope_dir}/doc
rm -rf $RPM_BUILD_ROOT%{_sysconfdir}/zope/skel/log
rm -f $RPM_BUILD_ROOT%{_sysconfdir}/zope/skel/bin/{runzope.bat,zopeservice.py}.in

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/zope
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/zope
install %{SOURCE3} $RPM_BUILD_ROOT/etc/logrotate.d/zope
install %{SOURCE4} $RPM_BUILD_ROOT%{_sbindir}/mkzopeinstance
install %{SOURCE5} $RPM_BUILD_ROOT%{_sbindir}/mkzeoinstance
install %{SOURCE6} $RPM_BUILD_ROOT%{_sbindir}/runzope
install %{SOURCE7} $RPM_BUILD_ROOT%{_sbindir}/zopectl
install %{SOURCE8} $RPM_BUILD_ROOT%{_sbindir}/installzopeproduct

touch $RPM_BUILD_ROOT/var/log/zope/main/event.log
touch $RPM_BUILD_ROOT/var/log/zope/main/Z2.log

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 112 zope
%useradd -u 112 -d /var/lib/zope/main -s /bin/false -c "Zope User" -g zope zope

%post
/sbin/chkconfig --add zope
# TODO: move this migration to trigger
if [ ! -f %{_sysconfdir}/zope/main/zope.conf ] ; then
	echo "Creating initial 'main' instance..."
	%{_sbindir}/mkzopeinstance main zope:zope
	echo "Instance created. Listening on 127.0.0.1:8080, initial user: 'zope' with password: 'zope'"
else
	echo "Old %{_sysconfdir}/zope/zope.conf detected - look at changes about upgrade!" >&2
fi
was_stopped=0
for dir in /var/lib/zope/main /var/lib/zope ; do
	if [ -f $dir/Data.fs ]; then
		echo "Found the database in old location. Migrating..."
		if [ -f /var/lock/subsys/zope ]; then
			/sbin/service zope stop >&2
			was_stopped=1
		fi
		umask 022
		[ -d /var/lib/zope/main ] && cd $dir && mv -f Data* /var/lib/zope/main/var 2>/dev/null
		if [ "x$was_stopped" = "x1" ]; then
			/sbin/service zope start >&2
		fi
		echo "Migration completed (new db location is /var/lib/zope/main/var)"
		break
	fi
done
if [ -f /var/lock/subsys/zope ]; then
	if [ "x$was_stopped" != "x1" ]; then
		/sbin/service zope restart >&2
	fi
else
	echo "look at %{_sysconfdir}/zope/main/zope.conf" >&2
	echo "Run then \"/sbin/service zope start\" to start Zope." >&2
	echo "You may create new Zope instances with mkzopeinstance" >&2
fi

%preun
if [ "$1" = "0" ]; then
	%service zope stop
	/sbin/chkconfig --del zope
fi

%postun
if [ "$1" = "0" ] ; then
	%userremove zope
	%groupremove zope
fi

%files
%defattr(644,root,root,755)
%doc doc/*
%attr(754,root,root) /etc/rc.d/init.d/zope
%attr(755,root,root) %{_sbindir}/*
%{zope_dir}
%attr(775,zope,zope) %dir /var/run/zope
%attr(775,zope,zope) %dir /var/lib/zope
%attr(775,zope,zope) %dir /var/lib/zope/main
%attr(775,zope,zope) %dir /var/log/zope
%attr(775,zope,zope) %dir /var/log/zope/main
%attr(640,root,root) %dir %{_sysconfdir}/zope
%attr(640,root,root) %dir %{_sysconfdir}/zope/skel
%attr(640,root,root) %dir %{_sysconfdir}/zope/main
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/zope/skel/*
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/zope
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/zope
%ghost /var/log/zope/main/event.log
%ghost /var/log/zope/main/Z2.log

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: Zope.spec,v $
Revision 1.99  2006/09/09 01:13:46  glen
- Patch4 was outdated

Revision 1.98  2006/09/09 01:12:26  glen
- rel 4 (rebuild with fixed %useradd/%groupadd macros)

Revision 1.97  2006/07/25 05:33:38  glen
- remove perl subst (it doesn't match)
- Hotfix-2006-07-05 needs to be applied

Revision 1.96  2006/04/14 14:10:45  glen
- rel 3: fix build with python 2.4.3

Revision 1.95  2006/04/14 11:34:29  glen
- rel 2

Revision 1.94  2006/02/24 15:20:04  glen
- use %service

Revision 1.93  2005/12/04 23:37:15  glen
- adapterized (sorted %verify flags)

Revision 1.92  2005/07/11 16:00:43  ciesiel
- upgraded to version 2.7.7

Revision 1.91  2005/05/11 13:22:05  qboosh
- use x8664 macro

Revision 1.90  2005/05/01 18:49:15  glen
- new spec syntax is so cool

Revision 1.89  2005/05/01 17:31:30  glen
- use %useradd/%groupadd macros

Revision 1.88  2005/04/29 15:29:59  ciesiel
- upgraded to version 2.7.6

Revision 1.87  2005/04/06 11:31:23  ciesiel
- added R: hotfix050405 (security)

Revision 1.86  2005/03/18 21:50:22  ciesiel
- upgraded to version 2.7.5-final

Revision 1.85  2005/01/14 21:15:19  ciesiel
- upgraded to version 2.7.4

Revision 1.84  2004/12/23 12:02:17  saq
- python24.patch: support building for python 2.4
- release 3

Revision 1.83  2004/12/23 11:50:44  saq
- rel 2 for rebuild with python 2.4

Revision 1.82  2004/11/27 19:01:23  saq
- massive attack: added missing python-devel epoch do BR

Revision 1.81  2004/10/24 09:06:27  ciesiel
- upgrade to version 2.7.3

Revision 1.80  2004/09/28 14:28:19  ciesiel
- rel.5

Revision 1.79  2004/09/28 07:35:08  jajcus
- apply the unicode_fix patch on all archs not only amd64 and alpha

Revision 1.78  2004/09/27 19:44:15  ciesiel
- added patch: fix for serving unicode documents with non text/*
  content type (needed for proper XHTML serving) (made by Jajcus)

Revision 1.77  2004/09/26 21:34:30  kolodko
- added macros in /etc/logrotate.d

Revision 1.76  2004/08/25 22:23:34  ankry
- added path in script

Revision 1.74  2004/08/25 22:10:42  ankry
- use %userremove/%groupremove, force standard GID/UID for user zope, rel. 3

Revision 1.73  2004/08/08 15:49:10  ankry
- spaces -> tabs

Revision 1.72  2004/08/06 19:08:19  aredridel
- rel 2 for fixed installzopeproduct
- STBR

Revision 1.71  2004/07/28 08:03:22  troll
- removed %include /usr/lib/rpm/macros.python

Revision 1.70  2004/07/20 18:47:34  ciesiel
- upgraded to version 2.7.2

Revision 1.69  2004/07/17 09:59:57  ciesiel
- modification hotfix

Revision 1.68  2004/07/13 17:25:49  ciesiel
- added req. (Hotfix)

Revision 1.67  2004/06/21 15:31:02  ciesiel
- upgraded to version 2.7.1

Revision 1.66  2004/06/12 13:02:32  ciesiel
- upgrade to version 2.7.1b2

Revision 1.65  2004/05/23 20:22:14  ciesiel
- upgraded to version 2.7.1b1

Revision 1.64  2004/05/02 08:20:51  ciesiel
- fixed zdctl warning after start

Revision 1.63  2004/02/13 14:49:12  jajcus
- Release: 5
- initgroups() call disabled on AMD64 and Alpha (it crashes on AMD64 and
  probably it would crash on Alpha too)

Revision 1.62  2004/02/12 09:44:14  ciesiel
- upgrade to version 2.7.0 (final)

Revision 1.61  2004/01/30 21:43:48  ciesiel
- upgraded to version 2.7.0 RC2

Revision 1.60  2004/01/20 08:58:18  ciesiel
- upgraded to 2.7.0rc1 version

Revision 1.59  2004/01/13 08:50:07  ciesiel
- added optimize
- cleanup

Revision 1.58  2004/01/10 14:33:22  qboosh
- cleanups

Revision 1.57  2004/01/10 14:29:58  ciesiel
- added message after upgrade

Revision 1.56  2004/01/10 13:33:52  ciesiel
- added patch (ln problem)
- finish but look at changes about upgrade!

Revision 1.55  2004/01/10 10:35:19  ciesiel
- upgraded to 2.7.0 b4 - security fix
- not finished yet

Revision 1.54  2003/12/10 08:18:29  ciesiel
- changed directory zope library (some products better works :)
- adapted to new python (2.3.3)

Revision 1.53  2003/12/04 08:29:33  ciesiel
- changes attributes on some dirs (more stable?) :)
- removed optimization (maybe later)

Revision 1.52  2003/11/27 20:01:04  ciesiel
- added and changed req.

Revision 1.51  2003/11/24 19:44:24  ciesiel
- remove req. Packages Zope-epoz is recommended but unstable with Zope beta3

Revision 1.50  2003/11/24 18:19:20  ciesiel
- added req.

Revision 1.49  2003/11/21 08:17:41  ciesiel
- upgraded to version 2.7.0 beta3

Revision 1.48  2003/11/18 12:52:21  ciesiel
- changed BR Perl to Perl-base (nice work) :)

Revision 1.47  2003/11/17 18:37:15  jajcus
- zope needs write access only to the var/ subdir of instance home

Revision 1.46  2003/11/16 09:09:58  jajcus
- 2.7.0 merged from DEVEL (2.6.2 won't work with python from HEAD anyway)

Revision 1.44.2.8  2003/11/15 15:12:50  jajcus
- Release: ....1
- installzopeproduct script added (to make protuct symlinks to instance homes)

Revision 1.44.2.7  2003/11/15 11:02:15  jajcus
- more FHS-compatible directory hierarchy
- use zopectl for controlling server

Revision 1.44.2.6  2003/11/15 00:12:52  jajcus
- works. comments and improvements are welcome

Revision 1.44.2.5  2003/11/14 17:09:25  jajcus
- working on...

Revision 1.44.2.4  2003/11/13 17:02:37  jajcus
- added patch to enable compilation with python 2.3.2
- rewritten to use Zope's makefile instead of ugly tricks including removing source files in %build (!!!)
- still NFY

Revision 1.44.2.3  2003/11/08 22:20:38  ciesiel
- fixed log

Revision 1.44.2.2  2003/11/08 22:14:21  ciesiel
- version 2.7b2
- removed docs (added later other packages)
- added skel (few files on the one arch)
- this builds not work - some errors after zope start :)
  TODO:
- compiled to pyc, pyo
- removed errors after start zope
- look at this work by practical user Zope :) - i'm so stupid :)))

Revision 1.44.2.1  2003/09/22 15:55:35  wiget
- start working with 2.7.0

Revision 1.45  2003/09/22 18:06:17  ciesiel
- BR
- updated req.

Revision 1.44  2003/09/10 21:19:26  ciesiel
- upgraded to 2.6.2
- not tested (RLIMIT_NOFILE grsec problem on kernel 2.4.21 :)

Revision 1.43  2003/08/22 15:16:38  ankry
- attributes fix

Revision 1.42  2003/08/18 08:07:53  gotar
- mass commit: cosmetics (removed trailing white spaces)

Revision 1.41  2003/08/12 07:46:03  qboosh
- post shouldn't depend on environment (use umask, initialize was_stopped)

Revision 1.40  2003/08/11 20:44:51  ankry
- cosmetics

Revision 1.39  2003/08/11 16:37:06  siefca
- fixed db migration script

Revision 1.38  2003/08/11 12:43:37  ankry
- typo

Revision 1.37  2003/08/10 21:22:14  siefca
- fixed typos in instance file
- fixed duplicates in files section
- dependencies downgraded to python 2.2

Revision 1.36  2003/08/10 18:05:10  siefca
- fixed install section for directories

Revision 1.35  2003/08/10 17:31:56  siefca
- fixed typo at Source5 installation

Revision 1.34  2003/08/10 17:29:44  siefca
- added migration scriptlet (untested)

Revision 1.33  2003/08/10 17:15:11  siefca
- patch has been fixed a bit (headline)

Revision 1.32  2003/08/10 16:38:38  siefca
- added install and attr sections for instance files

Revision 1.31  2003/08/07 10:04:21  ciesiel
- fixed Source0

Revision 1.30  2003/08/07 09:49:44  ciesiel
- typo

Revision 1.29  2003/08/07 09:46:43  ciesiel
- fixes few Sources
- TODO Zope.sysconfig not found in CVS repo

Revision 1.28  2003/08/06 16:08:35  siefca
- multiple instances support
- added patch on HTTP Accelerated Cache Manager for proper virtual hosts caching
- preparing for python 2.3
- version: 2.6.2b5

Revision 1.27  2003/07/20 08:55:08  ciesiel
- TODO: kill rest pids if zope WWW opened

Revision 1.26  2003/07/16 14:58:34  ciesiel
- cosmetics

Revision 1.25  2003/07/16 14:56:56  ciesiel
- refixed log zope

Revision 1.24  2003/07/16 14:06:59  ciesiel
- fixed logrotate directory and log zope

Revision 1.23  2003/07/16 09:03:28  ciesiel
- removed orphan source
- added Requires

Revision 1.22  2003/05/28 12:58:47  malekith
- massive attack: source-md5

Revision 1.21  2003/05/26 16:24:19  malekith
- massive attack: adding Source-md5

Revision 1.20  2003/05/25 05:45:23  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.19  2003/05/21 02:54:22  tjbynum
- I think Tutorial is inside.

Revision 1.18  2003/05/17 06:36:35  pascalek
- revert user changes

Revision 1.17  2003/05/10 09:03:35  pascalek
- Req user-zope

Revision 1.16  2003/04/19 04:54:58  kloczek
- cleanups and cosmetics,
- added logrotate support.

Revision 1.15  2003/04/18 06:16:02  kloczek
- removed gzipping %doc in %install.

Revision 1.14  2003/04/15 20:53:06  matkor
  In behalf of Adam Szpakowski <worf@optics.polsl.gliwice.pl>:
- version 2.6.1
- lot of documention added
- extended Zope-zserver.sh... corrections for 2.6.1 and locals support (pl_PL)
- changing default ports to 18080 and 18021 for compatibility with squid
- changes in Zope.init... cleaning + switching to CLIENT_HOME

Revision 1.13  2003/01/16 14:49:19  qboosh
- more Requires()

Revision 1.12  2002/11/25 14:53:17  marcus
- use new %doc

Revision 1.11  2002/11/19 13:38:04  martii
- python modules needed for Zope to work Req added (for ex zpasswd needs some modules)
- STBR rel 3

Revision 1.10  2002/11/14 12:26:57  speedy
- release 2
- fixed /var/lib/zope [sticky bit must be set]
- fixed ZServer/medusa/test
- STBR

Revision 1.9  2002/11/14 11:24:37  speedy
- just upgrade to 2.6.0
- python 2.2 support

Revision 1.8  2002/02/22 23:28:39  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.7  2002/01/18 02:12:17  kloczek
- perl -pi -e "s/pld-list\@pld.org.pl/feedback\@pld.org.pl/"

Revision 1.6  2001/11/24 22:58:40  filon
- updated to 2.4.3

Revision 1.5  2001/11/24 10:54:58  filon
- updated to 2.4.2

Revision 1.4  2001/10/31 10:34:51  qboosh
- pl translations, simplified %prep
- updated Source0 URL (note: 2.4.2 on http; also, zope.org suggests using
  ZopeBook instead of old guides (Source1-Source6))

Revision 1.3  2001/09/25 15:06:49  qboosh
- release 2: Prereq: /sbin/chkconfig

Revision 1.2  2001/09/06 16:15:19  kloczek
- merge some translations from CNV,
- cosmetics.

Revision 1.1  2001/09/06 13:41:13  mis
- works, but NFY
